/***********************************************************
	bernoulli number.c -- Bernoulli (xk[C) 
***********************************************************/
#include <stdio.h>
#include <stdlib.h>


/* ő */
long long gcd(long long x, long long y)
{
	long long t;

	while (y != 0) {  t = x % y;  x = y;  y = t;  }
	return x;
}

/* Tn Bn ϊ \*/
int TnToBn(int n, long long tn, long long q)
{
	long long b1, b2, g;
	char s[5] = " =  \0";

	b1 = n * tn;         	/* q */
	b2 = q * (q - 1);    	/*  */
	g = gcd(b1, b2);    	/* ő */
	b1 /= g;
	b2 /= g;
	if (n % 4 == 0) {     	/* ݒ */
		b1 *= -1;
		s[3] = '\0';
	} else s[3] = ' ';
	printf(" B(%2d)%s%lld / %lld\n", n, s, b1, b2);
	return 0;
}

#define  N 22                           	/* w */

int main()
{
	int j, n;
	long long b1, b2;
	static long long t[N - 1];
	long long q;

   /* B0 */
	n = 0; b1 = 1; b2 = 1;
	printf(" B(%2d) =  %lld / %lld\n", n, b1, b2);
   /* B1 */
	n = 1; b1 = -1; b2 = 2;
	printf(" B(%2d) = %lld / %lld\n", n, b1, b2);
   /* B2` */
	q = 1;         			            /* Wl */
	t[0] = 1;      			            /* qWl */
	/* Seidel's algorithm for Tn */
	for (n = 2; n < N ; n += 2) {
		q = q << 2;                     /* W q = q * 4 */
		TnToBn(n, t[0], q);                                     /* Bnl\ */
		for (j = 0; j <= n - 2; j++) t[j + 1] += t[j];   	    /* qWvZ */
		t[n] = t[n - 1];
		for (j = n - 2; j >= 0; j--) t[j + 1] = t[j] + t[j + 2];
		t[0] = t[1];
	}
	/* ŌBnl\ */
	q = q << 2;                         /* W q = q * 4 */
	TnToBn(N, t[0], q);

	printf("\n EnterL[ĉ");
	getchar();
	return EXIT_SUCCESS;
}

